## libktorrent 24.08.1

=== debian/changelog ===
libktorrent (24.08.1-3) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * Update symbols from buildds for 24.08.1.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 19 Sep 2024 09:59:23 +0200

libktorrent (24.08.1-2) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * Build with LTO enabled, update symbols accordingly. (Closes: #1015497)
  * Drop obsolete dh buildsystem from debian/rules, replaced by the dh-
    sequence dependency.
  * Reenable build-time tests.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 18 Sep 2024 23:28:09 +0200

libktorrent (24.08.1-1) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (24.08.1).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.7.0, no change required.
  * Adapt packaging to new libKTorrent6 library, drop ABI manager for this new
    library.
  * Add missing build dependency on kconfig and kcoreaddons.
  * Switch from transitional pkg-config to pkgconf build dependency.
  * Switch build to dh-sequence-kf6 sequence.
  * Review copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 15 Sep 2024 09:34:48 +0200

=== debian/control ===
Source: libktorrent
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               extra-cmake-modules (>= 5.240.0~),
               gettext,
               libboost-dev (>= 1.71.0~),
               libgcrypt20-dev (>= 1.4.5~),
               libgmp-dev,
               libkf6archive-dev (>= 5.240.0~),
               libkf6config-dev (>= 5.240.0~),
               libkf6coreaddons-dev (>= 5.240.0~),
               libkf6crash-dev (>= 5.240.0~),
               libkf6i18n-dev (>= 5.240.0~),
               libkf6kio-dev (>= 5.240.0~),
               libkf6solid-dev (>= 5.240.0~),
               pkg-kde-tools,
               pkgconf,
               qt6-5compat-dev,
               qt6-base-dev (>= 6.5.0~),
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.kde.org/applications/internet/ktorrent/
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/libktorrent.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/libktorrent

Package: libktorrent6-6
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Suggests: libktorrent-l10n (>= ${source:Version}),
Description: KTorrent library for C++ / Qt 5 / KDE Frameworks
 The KTorrent library is a C++ / Qt 5 / KDE Frameworks based implementation of
 the BitTorrent protocol (mostly client side).
 .
 The library supports connectivity to HTTP and UDP trackers, mainline DHT and
 the new generation Micro Transport Protocol (uTP). In addition, it provides
 many powerful BitTorrent network features including but not limited to torrent
 downloading and seeding, torrent creation and downloaded data verification,
 magnet links, advanced peer management, IP blocking lists.

Package: libktorrent-dev
Architecture: any
Section: libdevel
Depends: libboost-dev (>= 1.71.0~),
         libgcrypt20-dev (>= 1.4.5~),
         libgmp-dev,
         libktorrent6-6 (= ${binary:Version}),
         ${misc:Depends},
         ${sameVersionDep:libkf6archive-dev},
         ${sameVersionDep:libkf6config-dev},
         ${sameVersionDep:libkf6coreaddons-dev},
         ${sameVersionDep:libkf6i18n-dev},
         ${sameVersionDep:libkf6kio-dev},
         ${sameVersionDep:qt6-base-dev},
Description: development files for the KTorrent Library
 The KTorrent library is a C++ / Qt 5 / KDE Frameworks based implementation of
 the BitTorrent protocol (mostly client side).
 .
 This package contains header files, CMake modules and other files needed for
 developing and compiling/linking which use the KTorrent library.

Package: libktorrent-l10n
Architecture: all
Section: localization
Depends: ${misc:Depends},
Description: localization files for the KTorrent library
 The KTorrent library is a C++ / Qt 5 / KDE Frameworks based implementation of
 the BitTorrent protocol (mostly client side).
 .
 This package contains translations of the KTorrent library.

## libktorrent 24.08.2

=== debian/changelog ===
libktorrent (24.08.2-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.08.2)

 -- Rik Mills <rikmills@kde.org>  Sun, 03 Nov 2024 14:07:40 +0000

## libktorrent 24.11.90

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

cmake_policy(SET CMP0057 NEW)

# KDE Application Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "24")
set (RELEASE_SERVICE_VERSION_MINOR "11")
set (RELEASE_SERVICE_VERSION_MICRO "90")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")


set(Boost_MIN_VERSION "1.71.0")
set(LibGMP_MIN_VERSION "6.0.0")
set(LibGcrypt_MIN_VERSION "1.4.5")
set(KF_MIN_VERSION "5.240.0")
set(QT_MIN_VERSION "6.5.0")

set (SOVERSION 6)

project(LIBKTORRENT VERSION ${RELEASE_SERVICE_VERSION})

# set some default settings
enable_testing()

find_package(ECM ${KF_MIN_VERSION} NO_MODULE)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})

#
# checks for functions and stuff
#
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckTypeSize) #XFS

include(KDEInstallDirs)
include(KDECMakeSettings)
set(KDE_COMPILERSETTINGS_LEVEL "5.82")
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)
include(GenerateExportHeader)
include(ECMMarkAsTest)
include(ECMSetupVersion)
include(KDEClangFormat)
include(KDEGitCommitHooks)
include(CMakePackageConfigHelpers)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(QT_REQUIRED_VERSION "6.5.0")
set(KF_MIN_VERSION "5.240.0")
ecm_setup_version(${RELEASE_SERVICE_VERSION} VARIABLE_PREFIX LIBKTORRENT
                        VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/libktorrent_version.h"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KTorrent6ConfigVersion.cmake"
                        SOVERSION "${SOVERSION}")

find_package(Qt6 "${QT_MIN_VERSION}" CONFIG REQUIRED COMPONENTS
    Core
    Network
    Xml
    Test
)

find_package(Qt6Core5Compat REQUIRED)

# Load the frameworks we need
find_package(KF6 "${KF_MIN_VERSION}" REQUIRED COMPONENTS
    Archive
    Crash
    I18n
    KIO
    Solid
)

find_package(Boost "${Boost_MIN_VERSION}" MODULE REQUIRED)
find_package(LibGMP "${LibGMP_MIN_VERSION}" REQUIRED)
find_package(LibGcrypt "${LibGcrypt_MIN_VERSION}" REQUIRED)

kde_enable_exceptions()
add_definitions(
  -DQT_USE_QSTRINGBUILDER
  -DQT_NO_CAST_TO_ASCII
#   -DQT_NO_CAST_FROM_ASCII
  -DQT_STRICT_ITERATORS
  -DQT_NO_URL_CAST_FROM_STRING
  -DQT_NO_CAST_FROM_BYTEARRAY
  -DQT_NO_CAST_TO_BYTEARRAY
  -DQT_NO_KEYWORDS
  -DQT_USE_FAST_OPERATOR_PLUS
)
add_definitions(-DTRANSLATION_DOMAIN="libktorrent6")

option(WITH_XFS "Support for XFS specific disk preallocation" ON)
if(WITH_XFS)
    #XFS prealloc
    check_include_files(xfs/xfs.h HAVE_XFS_XFS_H)
    if(HAVE_XFS_XFS_H)
        set(CMAKE_EXTRA_INCLUDE_FILES xfs/xfs.h)
        check_type_size(__u64 HAVE___U64)
        check_type_size(__s64 HAVE___S64)
        set(CMAKE_EXTRA_INCLUDE_FILES)
        message(STATUS "xfsprogs found, building with XFS specific disk preallocation support")
    else()
        message(STATUS "xfsprogs NOT found, XFS specific disk preallocation unavailable")
    endif()
endif()

# check for 64 bit file I/O functions
check_function_exists(fopen64 HAVE_FOPEN64)
check_function_exists(fseeko64 HAVE_FSEEKO64)
check_function_exists(fseeko HAVE_FSEEKO)
check_function_exists(ftello64 HAVE_FTELLO64)
check_function_exists(ftello HAVE_FTELLO)
check_function_exists(fstat64 HAVE_FSTAT64)
check_function_exists(stat64 HAVE_STAT64)
check_function_exists(ftruncate64 HAVE_FTRUNCATE64)
check_function_exists(lseek64 HAVE_LSEEK64)
check_function_exists(mmap64 HAVE_MMAP64)
check_function_exists(munmap64 HAVE_MUNMAP64)
check_function_exists(posix_fallocate64 HAVE_POSIX_FALLOCATE64)
check_function_exists(posix_fallocate HAVE_POSIX_FALLOCATE)
check_function_exists(fallocate HAVE_FALLOCATE)
check_function_exists(statvfs HAVE_STATVFS)
check_function_exists(statvfs64 HAVE_STATVFS64)

add_subdirectory(src)
if(BUILD_TESTING)
    add_subdirectory(testlib)
endif()
add_subdirectory(examples)
add_subdirectory(doc)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KTorrent6")

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KTorrent6Config.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KTorrent6Config.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
                              PATH_VARS KDE_INSTALL_INCLUDEDIR
                              )

# Install the CMake modules needed to use libktorrent
add_subdirectory(cmake)

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/KTorrent6Config.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/KTorrent6ConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel)

install(EXPORT KTorrent6Targets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KTorrent6Targets.cmake)

ki18n_install(po)

# add clang-format target for all our real source files
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

## libktorrent 24.12.0

=== debian/changelog ===
libktorrent (24.12.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (24.12.0).
  * Update build-deps and deps with the info from cmake.
  * Update symbols from build for 24.12.0.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 25 Dec 2024 21:22:57 +0100

libktorrent (24.08.1-4) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Release to unstable.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 26 Nov 2024 21:07:56 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
-Build-Depends: cmake (>= 3.16~),
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
+               cmake (>= 3.16~),
                extra-cmake-modules (>= 5.240.0~),
                gettext,
                libboost-dev (>= 1.71.0~),

## libktorrent 24.12.1

=== debian/changelog ===
libktorrent (24.12.1-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.12.1)

 -- Rik Mills <rikmills@kde.org>  Sat, 11 Jan 2025 06:19:37 +0000

libktorrent (24.12.0-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.12.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 12 Dec 2024 17:23:43 +0000

libktorrent (24.11.90-0ubuntu1) plucky; urgency=medium

  * New upstream (RC) release (24.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 29 Nov 2024 13:09:21 +0000

libktorrent (24.11.80-0ubuntu1) plucky; urgency=medium

  * New upstream (beta) release (24.11.80)
  * Update symbols from build logs.

 -- Rik Mills <rikmills@kde.org>  Tue, 19 Nov 2024 17:22:07 +0000

libktorrent (24.08.3-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 07 Nov 2024 11:48:12 +0000

## libktorrent 24.12.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "24")
-set (RELEASE_SERVICE_VERSION_MINOR "11")
-set (RELEASE_SERVICE_VERSION_MICRO "90")
+set (RELEASE_SERVICE_VERSION_MINOR "12")
+set (RELEASE_SERVICE_VERSION_MICRO "3")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

=== cmake/CMakeLists.txt ===
install(FILES
    FindLibGMP.cmake
    FindLibGcrypt.cmake
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)

=== src/download/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(streamingchunkselectortest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)

=== debian/changelog ===
libktorrent (24.12.3-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Mar 2025 08:50:13 +0000

libktorrent (24.12.2-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Feb 2025 10:00:07 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: libktorrent
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
-               cmake (>= 3.16~),
                extra-cmake-modules (>= 5.240.0~),
                gettext,
                libboost-dev (>= 1.71.0~),
@@ -28,8 +29,8 @@
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.kde.org/applications/internet/ktorrent/
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/libktorrent.git
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/libktorrent
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libktorrent
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libktorrent
 
 Package: libktorrent6-6
 Architecture: any

## libktorrent 25.04.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,9 @@
 cmake_policy(SET CMP0057 NEW)
 
 # KDE Application Version, managed by release script
-set (RELEASE_SERVICE_VERSION_MAJOR "24")
-set (RELEASE_SERVICE_VERSION_MINOR "12")
-set (RELEASE_SERVICE_VERSION_MICRO "3")
+set (RELEASE_SERVICE_VERSION_MAJOR "25")
+set (RELEASE_SERVICE_VERSION_MINOR "04")
+set (RELEASE_SERVICE_VERSION_MICRO "0")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 
@@ -61,8 +61,6 @@
     Test
 )
 
-find_package(Qt6Core5Compat REQUIRED)
-
 # Load the frameworks we need
 find_package(KF6 "${KF_MIN_VERSION}" REQUIRED COMPONENTS
     Archive
@@ -72,7 +70,7 @@
     Solid
 )
 
-find_package(Boost "${Boost_MIN_VERSION}" MODULE REQUIRED)
+find_package(Boost "${Boost_MIN_VERSION}" NO_MODULE REQUIRED)
 find_package(LibGMP "${LibGMP_MIN_VERSION}" REQUIRED)
 find_package(LibGcrypt "${LibGcrypt_MIN_VERSION}" REQUIRED)
 
@@ -80,7 +78,7 @@
 add_definitions(
   -DQT_USE_QSTRINGBUILDER
   -DQT_NO_CAST_TO_ASCII
-#   -DQT_NO_CAST_FROM_ASCII
+  -DQT_NO_CAST_FROM_ASCII
   -DQT_STRICT_ITERATORS
   -DQT_NO_URL_CAST_FROM_STRING
   -DQT_NO_CAST_FROM_BYTEARRAY

=== src/util/CMakeLists.txt ===
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

set(util_HDR
    autorotatelogjob.h
    fileops.h
    timer.h
    ptrmap.h
    log.h
    waitjob.h
    urlencoder.h
    array.h
    functions.h
    file.h
    constants.h
    bitset.h
    sha1hash.h
    sha1hashgen.h
    error.h
    win32.h
    logsystemmanager.h
    compressfilejob.h
    decompressfilejob.h
    extractfilejob.h
    pipe.h
    circularbuffer.h
    resourcemanager.h
    bufferpool.h
)
if(NOT WIN32)
set(util_HDR ${util_HDR}
    signalcatcher.h
    )
endif(NOT WIN32)

install(FILES ${util_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/util COMPONENT Devel)

=== debian/changelog ===
libktorrent (25.04.0-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Update symbols from buildds for 25.04.0.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 04 May 2025 16:40:57 +0200

libktorrent (25.04.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (25.04.0).
  * Update symbols from build for 25.04.0.
  * Bump Standards-Version to 4.7.2, no change required.
  * Update project homepage.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 17 Apr 2025 22:02:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: libktorrent
 Section: libs
 Priority: optional
-Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
-Build-Depends: cmake (>= 3.16~),
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
+               cmake (>= 3.16~),
                extra-cmake-modules (>= 5.240.0~),
                gettext,
                libboost-dev (>= 1.71.0~),
@@ -26,11 +25,11 @@
                qt6-base-dev (>= 6.5.0~),
                xauth <!nocheck>,
                xvfb <!nocheck>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
-Homepage: https://www.kde.org/applications/internet/ktorrent/
-Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libktorrent
-Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libktorrent
+Homepage: https://invent.kde.org/network/libktorrent
+Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/libktorrent.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/libktorrent
 
 Package: libktorrent6-6
 Architecture: any

## libktorrent 25.04.3

=== debian/changelog ===
libktorrent (25.04.3-0ubuntu0~tux1) noble; urgency=medium

  * New upstream release.

 -- Torsten Wohlfarth <two@tuxedocomputers.com>  Tue, 02 Sep 2025 18:09:29 +0200

## libktorrent 25.07.80

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,14 +4,15 @@
 
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "04")
-set (RELEASE_SERVICE_VERSION_MICRO "0")
+set (RELEASE_SERVICE_VERSION_MINOR "07")
+set (RELEASE_SERVICE_VERSION_MICRO "80")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 
 set(Boost_MIN_VERSION "1.71.0")
 set(LibGMP_MIN_VERSION "6.0.0")
 set(LibGcrypt_MIN_VERSION "1.4.5")
+set(OpenSSL_MIN_VERSION "3.0.0")
 set(KF_MIN_VERSION "5.240.0")
 set(QT_MIN_VERSION "6.5.0")
 
@@ -21,6 +22,13 @@
 
 # set some default settings
 enable_testing()
+
+set(CRYPTO_BACKENDS "Auto" "OpenSSL" "LibGcrypt")
+set(USE_CRYPTO_BACKEND "Auto" CACHE STRING "Cryptography backend to use in libktorrent")
+set_property(CACHE USE_CRYPTO_BACKEND PROPERTY STRINGS ${CRYPTO_BACKENDS})
+if (NOT USE_CRYPTO_BACKEND IN_LIST CRYPTO_BACKENDS)
+    message(FATAL_ERROR "USE_CRYPTO_BACKEND must be one of: ${CRYPTO_BACKENDS}")
+endif()
 
 find_package(ECM ${KF_MIN_VERSION} NO_MODULE)
 
@@ -72,7 +80,22 @@
 
 find_package(Boost "${Boost_MIN_VERSION}" NO_MODULE REQUIRED)
 find_package(LibGMP "${LibGMP_MIN_VERSION}" REQUIRED)
-find_package(LibGcrypt "${LibGcrypt_MIN_VERSION}" REQUIRED)
+
+if (USE_CRYPTO_BACKEND STREQUAL "Auto" OR USE_CRYPTO_BACKEND STREQUAL "OpenSSL")
+    find_package(OpenSSL "${OpenSSL_MIN_VERSION}")
+endif()
+if (NOT OPENSSL_FOUND AND (USE_CRYPTO_BACKEND STREQUAL "Auto" OR USE_CRYPTO_BACKEND STREQUAL "LibGcrypt"))
+    find_package(LibGcrypt "${LibGcrypt_MIN_VERSION}")
+endif()
+if (OPENSSL_FOUND)
+    set(USE_OPENSSL 1)
+    set(USE_LIBGCRYPT 0)
+elseif (LibGcrypt_FOUND)
+    set(USE_LIBGCRYPT 1)
+    set(USE_OPENSSL 0)
+else()
+    message(FATAL_ERROR "No cryptography library found, USE_CRYPTO_BACKEND is ${USE_CRYPTO_BACKEND}")
+endif()
 
 kde_enable_exceptions()
 add_definitions(

=== debian/changelog ===
libktorrent (25.07.80-0ubuntu1) questing; urgency=medium

  * New upstream (beta) release (25.07.80)
  * Update symbols from build logs.
  * Build depend on libssl-dev

 -- Rik Mills <rikmills@kde.org>  Sat, 12 Jul 2025 18:25:26 +0100

libktorrent (25.04.3-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Jul 2025 07:55:32 +0100

libktorrent (25.04.2-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jun 2025 12:00:38 +0100

libktorrent (25.04.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 07 May 2025 22:17:37 +0100

libktorrent (25.04.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.0)
  * Update symbols from build logs.

 -- Rik Mills <rikmills@kde.org>  Wed, 30 Apr 2025 20:02:48 +0100

## libktorrent 25.07.90

=== debian/changelog ===
libktorrent (25.07.90-0ubuntu1) questing; urgency=medium

  * New upstream (RC) release (25.07.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Jul 2025 18:00:19 +0100

## libktorrent 25.08.0

=== debian/changelog ===
libktorrent (25.08.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 14 Aug 2025 11:34:12 +0100

## libktorrent 25.08.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,8 @@
 
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "07")
-set (RELEASE_SERVICE_VERSION_MICRO "80")
+set (RELEASE_SERVICE_VERSION_MINOR "08")
+set (RELEASE_SERVICE_VERSION_MICRO "1")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

=== src/mse/CMakeLists.txt ===
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

set(mse_HDR
    encryptedserverauthenticate.h
    functions.h
    rc4encryptor.h
    encryptedauthenticate.h
    bigint.h
    encryptedpacketsocket.h
)

install(FILES ${mse_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/mse COMPONENT Devel)

=== src/dht/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(rpcmsgtest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)
ecm_add_test(keytest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)

=== src/utp/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(localwindowtest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(remotewindowtest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(connectiontest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(sendtest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(connecttest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(transmittest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(packetlosstest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(fintest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(sockettest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(utppolltest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(delaywindowtest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(packetbuffertest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)

=== debian/changelog ===
libktorrent (25.08.1-0zneon+24.04+noble+release+build19) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Tue, 09 Sep 2025 13:14:51 +0000

libktorrent (25.08.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 09 Sep 2025 09:02:45 +0000

libktorrent (25.08.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 14 Aug 2025 12:37:46 +0000

libktorrent (25.04.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 05 Jul 2025 11:19:48 +0000

libktorrent (25.04.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 05 Jun 2025 10:36:17 +0000

libktorrent (25.04.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 08 May 2025 04:27:51 +0000

libktorrent (25.04.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 17 Apr 2025 13:23:59 +0000

libktorrent (24.12.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 08 Mar 2025 13:37:06 +0000

libktorrent (24.12.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 07 Feb 2025 14:46:03 +0000

libktorrent (24.12.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 09 Jan 2025 19:37:08 +0000

libktorrent (24.12.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 11 Dec 2024 18:34:51 +0000

libktorrent (24.08.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 07 Nov 2024 10:34:58 +0000

libktorrent (24.08.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 14 Oct 2024 21:06:42 +0000

libktorrent (24.08.1-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sun, 22 Sep 2024 07:44:29 +0000

libktorrent (24.08.0-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 19 Jun 2024 10:00:37 +0000

libktorrent (24.05.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 11 Apr 2024 11:35:53 +0000

libktorrent (24.02.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 20 Mar 2024 17:04:33 +0000

libktorrent (24.02.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Sat, 24 Feb 2024 03:49:50 +0000

libktorrent (23.08.5-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 19 Feb 2024 14:45:36 +0000

libktorrent (23.08.4-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 06 Dec 2023 16:28:26 +0000

libktorrent (23.08.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 08 Nov 2023 13:31:31 +0000

libktorrent (23.08.2-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 11 Oct 2023 17:05:23 +0000

libktorrent (23.08.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 14 Sep 2023 00:46:34 +0000

libktorrent (23.08.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 24 Aug 2023 09:33:59 +0000

libktorrent (23.04.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 06 Jun 2023 21:59:49 +0000

libktorrent (22.12.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 02 Mar 2023 12:47:30 +0000

libktorrent (22.12.2-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 01 Feb 2023 17:13:50 +0000

libktorrent (22.12.1-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 05 Jan 2023 15:54:01 +0000

libktorrent (22.12.0-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 07 Dec 2022 12:01:51 +0000

libktorrent (22.08.3-0neon) jammy; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 03 Nov 2022 09:22:15 +0000

libktorrent (22.08.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 14 Oct 2022 17:53:46 +0000

libktorrent (22.08.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 18 Aug 2022 09:24:23 +0000

libktorrent (22.04.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 07 Jul 2022 12:11:33 +0000

libktorrent (22.04.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 07 Jun 2022 20:36:34 +0000

libktorrent (22.04.1-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 10 May 2022 13:27:52 +0000

libktorrent (22.04.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 18 Apr 2022 12:42:30 +0000

libktorrent (21.12.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 03 Mar 2022 11:00:50 +0000

libktorrent (21.12.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 03 Feb 2022 10:55:45 +0000

libktorrent (21.12.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 06 Dec 2021 23:07:28 +0000

libktorrent (21.08.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 06 Oct 2021 13:33:47 +0000

libktorrent (21.08.1-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 01 Sep 2021 09:30:14 +0000

libktorrent (21.08.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Tue, 10 Aug 2021 12:26:31 +0000

libktorrent (21.04.3-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 12 Jul 2021 11:47:08 +0000

libktorrent (21.04.2-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 11 Jun 2021 08:19:05 +0000

libktorrent (21.04.1-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Thu, 13 May 2021 08:49:24 +0000

libktorrent (21.04.0-0neon) focal; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Mon, 19 Apr 2021 10:17:08 +0000



## libktorrent 25.08.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
 set (RELEASE_SERVICE_VERSION_MINOR "08")
-set (RELEASE_SERVICE_VERSION_MICRO "1")
+set (RELEASE_SERVICE_VERSION_MICRO "2")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

=== examples/ktcli/CMakeLists.txt ===
add_executable(ktcli)

target_sources(ktcli PRIVATE
    ktcli.cpp
    main.cpp
)

target_link_libraries(ktcli KTorrent6)

=== src/diskio/CMakeLists.txt ===
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

set(diskio_HDR
    cache.h
    cachefile.h
    singlefilecache.h
    preallocationthread.h
    preallocationjob.h
    movedatafilesjob.h
    deletedatafilesjob.h
    chunkmanager.h
    dndfile.h
    chunk.h
    multifilecache.h
    piecedata.h
)

install(FILES ${diskio_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/diskio COMPONENT Devel)

=== src/torrent/CMakeLists.txt ===
set(torrent_HDR
    torrent.h
    advancedchokealgorithm.h
    peersourcemanager.h
    choker.h
    server.h
    torrentcontrol.h
    uploader.h
    torrentcreator.h
    timeestimator.h
    torrentfile.h
    statsfile.h
    globals.h
    torrentstats.h
    job.h
    jobqueue.h
    torrentfilestream.h
)

install(FILES ${torrent_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/torrent COMPONENT Devel)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== src/datachecker/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(datacheckertest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)

=== src/mse/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(rc4encryptortest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)

=== src/torrent/tests/CMakeLists.txt ===
include(ECMAddTests)

ecm_add_test(statsfiletest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(torrentfilestreamtest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)
ecm_add_test(torrentfilestreammultitest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)

=== debian/changelog ===
libktorrent (25.08.2-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.2)

 -- Rik Mills <rikmills@kde.org>  Fri, 17 Oct 2025 11:56:48 +0100

libktorrent (25.08.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.08.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 11 Sep 2025 06:58:54 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

%:
	dh $@

override_dh_auto_test:
	xvfb-run -a dh_auto_test

execute_after_dh_shlibdeps:
	dh_sameversiondep

## libktorrent 25.08.2+p24.04+vstable+git20251015.1233

=== debian/changelog ===
libktorrent (25.08.2+p24.04+vstable+git20251015.1233-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 12:33:24 +0000

libktorrent (25.08.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 10 Oct 2025 03:49:10 +0000

## libktorrent 25.08.2+p24.04+vstable+git20251019.0351

=== debian/changelog ===
libktorrent (25.08.2+p24.04+vstable+git20251019.0351-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 19 Oct 2025 03:51:05 +0000

## libktorrent 25.08.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
 set (RELEASE_SERVICE_VERSION_MINOR "08")
-set (RELEASE_SERVICE_VERSION_MICRO "2")
+set (RELEASE_SERVICE_VERSION_MICRO "3")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

=== doc/CMakeLists.txt ===
find_package(Doxygen)
if (DOXYGEN_FOUND AND DOXYGEN_DOT_FOUND)
    message (STATUS "Doxygen and dot found. make docs target is available")
    # Add support for a docs target

    set(TAGFILES "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=http://qt.nokia.com/doc/${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}")
    set(DOCS_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/apidocs")
    configure_file("Doxyfile.in" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" IMMEDIATE @ONLY)

    # Add support for a Qt assistant docs target
    # qttags.tag is too big to distribute with Grantlee. Get it
    # from http://api.kde.org/kdereview-api/kdereview.tar.gz for example.
    if(EXISTS ${CMAKE_SOURCE_DIR}/scripts/qttags.tag)
        set(DOCS_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/qtdocs")
        set(TAGFILES "${CMAKE_SOURCE_DIR}/scripts/qttags.tag=qthelp://com.trolltech.qt/qdoc/")
        set(GENERATE_QHP "yes")

        configure_file("${CMAKE_MODULE_PATH}/Doxyfile.in" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.qt" IMMEDIATE @ONLY)
    endif()

    set( DOCS_ARGS ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile")
    if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.qt")
        set(DOCS_ARGS ${DOCS_ARGS} COMMAND ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.qt")
    endif()

    add_custom_target(docs ${DOCS_ARGS})
endif()

=== src/CMakeLists.txt ===
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config-ktorrent.h.cmake ${CMAKE_BINARY_DIR}/config-ktorrent.h)

remove_definitions(-DQT_NO_HTTP)

add_library(KTorrent6)
set_target_properties(KTorrent6 PROPERTIES
    VERSION     ${RELEASE_SERVICE_VERSION}
    SOVERSION   ${SOVERSION}
    EXPORT_NAME KTorrent6
)

target_sources(KTorrent6 PRIVATE
    util/bitset.cpp
    util/timer.cpp
    util/urlencoder.cpp
    util/sha1hashgen.cpp
    util/sha1hash.cpp
    util/functions.cpp
    util/ptrmap.cpp
    util/array.cpp
    util/error.cpp
    util/file.cpp
    util/fileops.cpp
    util/log.cpp
    util/waitjob.cpp
    util/autorotatelogjob.cpp
    util/compressfilejob.cpp
    util/decompressfilejob.cpp
    util/extractfilejob.cpp
    util/logsystemmanager.cpp
    util/pipe.cpp
    util/circularbuffer.cpp
    util/resourcemanager.cpp
    util/bufferpool.cpp

    bcodec/bdecoder.cpp
    bcodec/bencoder.cpp
    bcodec/bnode.cpp
    bcodec/value.cpp

    net/address.cpp
    net/packetsocket.cpp
    net/portlist.cpp
    net/socket.cpp
    net/socketmonitor.cpp
    net/speed.cpp
    net/uploadthread.cpp
    net/downloadthread.cpp
    net/networkthread.cpp
    net/socketgroup.cpp
    net/socks.cpp
    net/wakeuppipe.cpp
    net/reverseresolver.cpp
    net/socketdevice.cpp
    net/poll.cpp
    net/serversocket.cpp
    net/addressresolver.cpp
    net/trafficshapedsocket.cpp
    net/streamsocket.cpp

    mse/bigint.cpp
    mse/functions.cpp
    mse/rc4encryptor.cpp
    mse/encryptedpacketsocket.cpp
    mse/encryptedauthenticate.cpp
    mse/encryptedserverauthenticate.cpp

    peer/authenticatebase.cpp
    peer/authenticate.cpp
    peer/serverauthenticate.cpp
    peer/authenticationmonitor.cpp
    peer/chunkcounter.cpp
    peer/peerid.cpp
    peer/peer.cpp
    peer/peermanager.cpp
    peer/peerdownloader.cpp
    peer/peeruploader.cpp
    peer/packetreader.cpp
    peer/peerprotocolextension.cpp
    peer/utpex.cpp
    peer/utmetadata.cpp
    peer/accessmanager.cpp
    peer/badpeerslist.cpp
    peer/peerconnector.cpp
    peer/superseeder.cpp
    peer/connectionlimit.cpp

    #download/piece.cpp all the code is inlined
    #download/request.cpp all the code is inlined
    download/packet.cpp
    download/webseed.cpp
    download/chunkdownload.cpp
    download/chunkselector.cpp
    download/downloader.cpp
    download/httpconnection.cpp
    download/httpresponseheader.cpp
    download/streamingchunkselector.cpp

    interfaces/piecedownloader.cpp
    interfaces/peerinterface.cpp
    interfaces/peersource.cpp
    interfaces/torrentinterface.cpp
    interfaces/torrentfileinterface.cpp
    interfaces/trackerslist.cpp
    interfaces/logmonitorinterface.cpp
    interfaces/blocklistinterface.cpp
    interfaces/exitoperation.cpp
    interfaces/chunkdownloadinterface.cpp
    interfaces/monitorinterface.cpp
    interfaces/queuemanagerinterface.cpp
    interfaces/chunkselectorinterface.cpp
    interfaces/cachefactory.cpp
    interfaces/webseedinterface.cpp
    interfaces/trackerinterface.cpp
    interfaces/serverinterface.cpp

    torrent/globals.cpp
    torrent/server.cpp
    torrent/torrent.cpp
    torrent/torrentfile.cpp
    torrent/peersourcemanager.cpp
    torrent/uploader.cpp
    torrent/timeestimator.cpp
    torrent/statsfile.cpp
    torrent/choker.cpp
    torrent/advancedchokealgorithm.cpp
    torrent/torrentcontrol.cpp
    torrent/torrentcreator.cpp
    torrent/torrentstats.cpp
    torrent/jobqueue.cpp
    torrent/job.cpp
    torrent/torrentfilestream.cpp

    dht/announcetask.cpp
    dht/dht.cpp
    dht/kclosestnodessearch.cpp
    dht/nodelookup.cpp
    dht/rpcmsg.cpp
    dht/rpcmsgfactory.cpp
    dht/taskmanager.cpp
    dht/database.cpp
    dht/dhtpeersource.cpp
    dht/key.cpp
    dht/pack.cpp
    dht/rpcserver.cpp
    dht/rpcserverinterface.cpp
    dht/dhtbase.cpp
    dht/kbucket.cpp
    dht/kbucketentry.cpp
    dht/kbuckettable.cpp
    dht/node.cpp
    dht/rpccall.cpp
    dht/task.cpp
    dht/packednodecontainer.cpp
    dht/errmsg.cpp
    dht/pingreq.cpp
    dht/findnodereq.cpp
    dht/getpeersreq.cpp
    dht/announcereq.cpp
    dht/pingrsp.cpp
    dht/findnodersp.cpp
    dht/getpeersrsp.cpp
    dht/announcersp.cpp

    diskio/cache.cpp
    diskio/chunk.cpp
    diskio/dndfile.cpp
    diskio/singlefilecache.cpp
    diskio/multifilecache.cpp
    diskio/preallocationthread.cpp
    diskio/preallocationjob.cpp
    diskio/movedatafilesjob.cpp
    diskio/deletedatafilesjob.cpp
    diskio/piecedata.cpp
    diskio/cachefile.cpp
    diskio/chunkmanager.cpp

    tracker/httptracker.cpp
    tracker/tracker.cpp
    tracker/udptracker.cpp
    tracker/udptrackersocket.cpp
    tracker/trackermanager.cpp
    #tracker/httpannouncejob.cpp
    tracker/kioannouncejob.cpp

    datachecker/datachecker.cpp
    datachecker/datacheckerthread.cpp
    datachecker/singledatachecker.cpp
    datachecker/multidatachecker.cpp
    datachecker/datacheckerjob.cpp

    magnet/magnetdownloader.cpp
    magnet/magnetlink.cpp
    magnet/metadatadownload.cpp

    utp/utpserver.cpp
    utp/utpserverthread.cpp
    utp/connection.cpp
    utp/localwindow.cpp
    utp/remotewindow.cpp
    utp/utpsocket.cpp
    utp/timevalue.cpp
    utp/utpprotocol.cpp
    utp/pollpipe.cpp
    utp/delaywindow.cpp
    utp/outputqueue.cpp
    utp/packetbuffer.cpp

    upnp/soap.cpp
    upnp/upnpmcastsocket.cpp
    upnp/upnprouter.cpp
    upnp/upnpdescriptionparser.cpp
    upnp/httprequest.cpp

    version.cpp
)

if(NOT WIN32)
# Add signalcatcher.cpp for all builds except WIN32
    target_sources(KTorrent6 PRIVATE util/signalcatcher.cpp)
endif(NOT WIN32)

if(WIN32)
# Compile stuff for windows
    target_sources(KTorrent6 PRIVATE util/win32.cpp)
endif(WIN32)


# ki18n_wrap_ui(KTorrent6 ${libktorrent_UI})
# kconfig_add_kcfg_files(KTorrent6 settings.kcfgc)

generate_export_header(KTorrent6 BASE_NAME ktorrent)

target_link_libraries(KTorrent6
PUBLIC
    KF6::Archive
    KF6::KIOCore
    KF6::KIOWidgets
    KF6::Solid
    KF6::I18n
    Qt6::Xml
    Boost::boost
    LibGMP::LibGMP
)

if (USE_OPENSSL)
    target_compile_definitions(KTorrent6 PUBLIC LIBKTORRENT_USE_OPENSSL=1)
    target_link_libraries(KTorrent6 PUBLIC OpenSSL::Crypto)
elseif (USE_LIBGCRYPT)
    target_compile_definitions(KTorrent6 PUBLIC LIBKTORRENT_USE_LIBGCRYPT=1)
    target_link_libraries(KTorrent6 PUBLIC LibGcrypt::LibGcrypt)
endif()

if(WIN32)
target_link_libraries(KTorrent6 PUBLIC ws2_32)
endif(WIN32)
if(HAIKU)
target_link_libraries(KTorrent6 PUBLIC network)
endif(HAIKU)
target_include_directories(KTorrent6 INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent>")
target_include_directories(KTorrent6 PUBLIC "$<BUILD_INTERFACE:${LIBKTORRENT_SOURCE_DIR}/src;${LIBKTORRENT_BINARY_DIR}/src;${LIBKTORRENT_BINARY_DIR}>")


install(TARGETS KTorrent6 EXPORT KTorrent6Targets ${KF_INSTALL_TARGETS_DEFAULT_ARGS})

set (interfaces_HDR
    interfaces/peerinterface.h
    interfaces/queuemanagerinterface.h
    interfaces/exitoperation.h
    interfaces/chunkdownloadinterface.h
    interfaces/trackerslist.h
    interfaces/torrentinterface.h
    interfaces/logmonitorinterface.h
    interfaces/piecedownloader.h
    interfaces/monitorinterface.h
    interfaces/blocklistinterface.h
    interfaces/torrentfileinterface.h
    interfaces/peersource.h
    interfaces/chunkselectorinterface.h
    interfaces/cachefactory.h
    interfaces/webseedinterface.h
    interfaces/trackerinterface.h
    interfaces/serverinterface.h
)

set (ktorrent_HDR
    ${CMAKE_CURRENT_BINARY_DIR}/ktorrent_export.h
    ${CMAKE_BINARY_DIR}/libktorrent_version.h
    version.h
)

set (bcodec_HDR
    bcodec/bencoder.h
    bcodec/bnode.h
    bcodec/bdecoder.h
    bcodec/value.h
)

install(FILES ${bcodec_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/bcodec COMPONENT Devel)
install(FILES ${interfaces_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/interfaces COMPONENT Devel)
install(FILES ${migrate_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/migrate COMPONENT Devel)
install(FILES ${ktorrent_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent COMPONENT Devel)

add_subdirectory(torrent)
add_subdirectory(datachecker)
add_subdirectory(download)
add_subdirectory(diskio)
add_subdirectory(peer)
add_subdirectory(net)
add_subdirectory(mse)
add_subdirectory(magnet)
add_subdirectory(util)
add_subdirectory(utp)
add_subdirectory(upnp)
add_subdirectory(tracker)
add_subdirectory(dht)

=== src/dht/CMakeLists.txt ===
set(dht_HDR
    dhtbase.h
    rpcserver.h
    rpcserverinterface.h
    key.h
    pack.h
    rpcmsg.h
    dhtpeersource.h
    announcetask.h
    rpccall.h
    kclosestnodessearch.h
    dht.h
    node.h
    task.h
    nodelookup.h
    taskmanager.h
    kbucket.h
    kbucketentry.h
    kbuckettable.h
    database.h
    announcereq.h
    announcersp.h
    pingreq.h
    pingrsp.h
    findnodereq.h
    findnodersp.h
    getpeersreq.h
    getpeersrsp.h
    rpcmsgfactory.h
)

install(FILES ${dht_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/dht COMPONENT Devel)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== src/net/CMakeLists.txt ===
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

set(net_HDR
    socks.h
    packetsocket.h
    trafficshapedsocket.h
    streamsocket.h
    downloadthread.h
    address.h
    addressresolver.h
    socketgroup.h
    portlist.h
    networkthread.h
    socket.h
    speed.h
    uploadthread.h
    socketmonitor.h
    reverseresolver.h
    socketdevice.h
    poll.h
    wakeuppipe.h
    serversocket.h
)

install(FILES ${net_HDR} DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/libktorrent/net COMPONENT Devel)

=== src/diskio/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(chunkmanagertest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)
ecm_add_test(preallocationtest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)

=== src/magnet/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(magnetlinktest.cpp LINK_LIBRARIES testlib KTorrent6 Qt6::Test)

=== src/net/tests/CMakeLists.txt ===
include(ECMAddTests)
ecm_add_test(polltest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)
ecm_add_test(wakeuppipetest.cpp LINK_LIBRARIES KTorrent6 Qt6::Test)

=== debian/changelog ===
libktorrent (25.08.3-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Nov 2025 12:19:51 +0000

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: libktorrent
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-pkgkde-symbolshelper,
-               cmake (>= 3.16~),
                extra-cmake-modules (>= 5.240.0~),
                gettext,
                libboost-dev (>= 1.71.0~),
@@ -19,17 +20,18 @@
                libkf6i18n-dev (>= 5.240.0~),
                libkf6kio-dev (>= 5.240.0~),
                libkf6solid-dev (>= 5.240.0~),
+               libssl-dev,
                pkg-kde-tools,
                pkgconf,
                qt6-5compat-dev,
                qt6-base-dev (>= 6.5.0~),
                xauth <!nocheck>,
                xvfb <!nocheck>,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
-Homepage: https://invent.kde.org/network/libktorrent
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/libktorrent.git
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/libktorrent
+Homepage: https://www.kde.org/applications/internet/ktorrent/
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libktorrent
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/libktorrent
 
 Package: libktorrent6-6
 Architecture: any

## libktorrent 25.08.3+p24.04+vstable+git20251204.0902

=== debian/changelog ===
libktorrent (25.08.3+p24.04+vstable+git20251204.0902-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 04 Dec 2025 09:02:15 +0000

libktorrent (25.08.3-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 07 Nov 2025 00:46:10 +1000

## libktorrent 25.08.3+p24.04+vunstable+git20251123.1236

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,9 @@
 cmake_policy(SET CMP0057 NEW)
 
 # KDE Application Version, managed by release script
-set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "08")
-set (RELEASE_SERVICE_VERSION_MICRO "3")
+set (RELEASE_SERVICE_VERSION_MAJOR "26")
+set (RELEASE_SERVICE_VERSION_MINOR "03")
+set (RELEASE_SERVICE_VERSION_MICRO "70")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

=== debian/changelog ===
libktorrent (25.08.3+p24.04+vunstable+git20251123.1236-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 23 Nov 2025 12:36:47 +0000

## libktorrent 25.08.3+p24.04+vunstable+git20251128.0750

=== debian/changelog ===
libktorrent (25.08.3+p24.04+vunstable+git20251128.0750-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 28 Nov 2025 07:50:13 +0000
